#set-env BAT_THEME Coldark-Cold
set-env BAT_PAGER 'less -RF'
set-env EDITOR vim
set-env VIEW 'vim -R'
set-env CURRENT_SHELL 'elvish'
set-env STARSHIP_CONFIG ~/.config/starship/starship.toml
set paths = [$@paths /home/benjamin/bin /home/benjamin/Go/bin ]

{
  use moi/util/list
  if (list:includes-not /usr/local/bin $paths) {
    set paths = [ $@paths /usr/local/bin ]
  }
}

set notify-bg-job-success = $false

set edit:insert:binding[Tab]    = { edit:completion:smart-start; edit:navigation:trigger-filter }
set edit:insert:binding[Ctrl-H] = $edit:histlist:start~

set edit:prompt  = { go-prompt }
set edit:rprompt = { nop }
#eval (starship init elvish)
eval (starship init elvish --print-full-init | upgrade-scripts-for-0.17 -lambda | slurp)

# Carapace completion : https://github.com/rsteube/carapace-bin
eval (carapace _carapace|slurp)

# On ajoute les modules natifs que j’utilise beaucoup
use str
use re
use math

use moi/completion
use moi/alias
use moi/util/common
use moi/util/format

{
  use ./aliases/get-uid uid
  if (not (uid:-is-root)) {
    tache search -d 2w not del
  }
}
